package org.seasar.remoting.xmlrpc;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.io.OutputStream;
import java.io.IOException;

import org.apache.xmlrpc.XmlRpcServer;

import org.seasar.framework.container.factory.SingletonS2ContainerFactory;
import org.seasar.framework.container.S2Container;

public class XmlRpcServlet extends HttpServlet {

	public void doPost(HttpServletRequest req, HttpServletResponse res)
			throws ServletException, IOException {
		String componentName = req.getPathInfo().substring(1);
		S2Container container = SingletonS2ContainerFactory.getContainer();
		Object component = container.getComponent(componentName);

		XmlRpcServer server = new XmlRpcServer();
		server.addHandler(componentName, component);

		byte[] result = server.execute(req.getInputStream());
		res.setContentType("text/xml");
		res.setContentLength(result.length);

		OutputStream os = res.getOutputStream();
		os.write(result);
		os.flush();
	}
}